Skip to main content
To chat with customers and leads on your website using HubSpot’s conversation inbox, you can set up a live chat widget. With the conversations SDK, you can provide a more tailored experience for visitors by customizing the behavior of the chat widget. At a high level, the conversations SDK enables you to do the following:

Initializing

The API is housed in the window.HubSpotConversations object, which provides access to all available methods. The object is created by the HubSpot tracking code, but may not be available immediately on page load. To defer accessing the API until it’s initialized, you can use the window.hsConversationsOnReady helper. window.hsConversationsOnReady is an optional field you can define on the window object which enables you to specify code to be executed as soon as the widget becomes available. This field takes an array functions to be executed once the API has been initialized.

Configure conversations settings

hsConversationsSettings This optional object enables you to provide some configuration options to the widget before it initializes.

Inline embed styling

When the widget is embedded in a specific location using inlineEmbedSelector, several DOM elements are added and can be styled (e.g. height, width, border). For example, if you embed the chat widget using the #some-id selector, it would be loaded with the following containers and IDs:
You can then customize the chat widget using those selectors, such as:
livechat_after

Widget behavior

HubSpotConversations.widget The widget object contains a number of methods that allow you to manipulate the chat widget on your page, including: Below, learn more about each method.

widget.load

The widget.load method handles the initial load on the page. This method is only necessary if you set loadImmediately to false. Otherwise, the widget will load itself automatically. This method is throttled to one call per second.

widget.refresh

The widget.refresh method handles refreshing and re-rendering the widget’s information, given the current page URL. This method can be useful for chat widgets embedded in single-page applications when you need to refresh the widget on route changes. This method also enables you to specify different chat widgets on different page routes. If you call widget.refresh on a route where there is no chat widget, and the user isn’t engaged in a chat, the widget will be removed. It will not remove the widget when there is a currently active chat. This method is throttled to one call per second.

Example

Using this method, you could create buttons and links to open specific chatflows on a page by adding query parameters to the page URL. conversations-chat-widget-open-cropFor example, you could add the following code to your pages to generate the buttons:
Then, in each chat’s target settings, you would set the chat to display when the query parameter matches the one you’ve set in your button code. conversations-target-rule

widget.open

The widget.open method opens the widget if it is not already open or isn’t currently loaded.

widget.close

The widget.close method closes the widget if it isn’t already closed.

widget.remove

The widget.remove method removes the widget from the page. If the widget isn’t present on the page, this method does nothing. The widget will display again on page refresh or if widget.load is invoked.

widget.status

The widget.status method returns an object containing properties related to the current status of the widget.

Clear chat cookies

The clear method deletes cookies related to the chat widget and returns it to its default state on subsequent load. The chat widget creates several cookies to preserve its state across site visits and page refreshes. These cookies are scoped to the domain of the page hosting the widget, and are used to support the following features:
  • Referencing historical conversations.
  • Persisting the open state of the chat widget across page loads.
  • Persisting the open state of the welcome message across page loads.
The following cookies are cleared with this method:
  • messagesUtk
  • hs-messages-is-open
  • hs-messages-hide-welcome-message
For more information about these cookies, see check out HubSpot’s Knowledge Base.
Additionally, you can pass {resetWidget:true} to the clear() function to clear all chat related cookies, remove the widget from the page, and create a new instance of the chat widget.

Chat events

The chat widget emits various events you can listen and respond to throughout its lifecycle. These events include: To register and remove event listeners, you’ll use on and off, as shown below.
Learn more about each event below.

conversationStarted

The conversationStarted event triggers when a new conversation has been successfully started.

conversationClosed

The conversationClosed event triggers when a new conversation has marked as closed from the conversations inbox. Site visitors minimizing or closing the chat widget will not trigger this event. For that event, use widgetClosed instead.

userSelectedThread

The userSelectedThread event triggers when creating a thread or selecting an existing thread.

unreadConversationCountChanged

The unreadConversationCountChanged event is triggered when the number of conversations with unread messages increases or decreases.

contactAssociated

The contactAssociated event is triggered when the visitor is associated with a contact in the CRM.

userInteractedWithWidget

The userInteractedWithWidget event is triggered when the visitor interacts with the widget, such as clicking to open the widget or closing the initial welcome message.

widgetLoaded

The widgetLoaded event is triggered when the widget iframe is loaded.

quickReplyButtonClick

The quickReplyButtonClick event is triggered when the visitor clicks a quick reply in a bot conversation.
quick-reply-options-in-bot-conversation In the example screenshot above, the bot chatflow contains three quick reply options. If the user selects Learn more, the resulting event payload would be:

widgetClosed

The widgetClosed event is triggered when the visitor closes the chat widget.
Last modified on June 4, 2026